<script>
import axios from "axios";

export default {
  data() {
    return {
      buku: {
        id: "",
        title: "",
        author: "",
        synopsis: "",
        genre_id: "",
        price: "",
        cover: null,
      },
      genres: [],
      errorMessage: '',
      successMessage: ''
    };
  },
  mounted() {
    const bukuId = this.$route.params.id;
    this.fetchBuku(bukuId);
    this.fetchGenres();
  },
  methods: {
    fetchBuku(id) {
      axios
        .get(`http://localhost:8000/api/buku/${id}`)
        .then((response) => {
          this.buku = response.data;
          console.log("Data buku berhasil diambil:", this.buku);
        })
        .catch((error) => {
          console.error("Error fetching book:", error);
        });
    },
    fetchGenres() {
      axios
        .get("http://localhost:8000/api/genre")
        .then((response) => {
          this.genres = response.data;
        })
        .catch((error) => {
          console.error("Error fetching genres:", error);
        });
    },
    editBuku() {
      const formData = new FormData();
      formData.append("title", this.buku.title);
      formData.append("author", this.buku.author);
      formData.append("synopsis", this.buku.synopsis);
      formData.append("genre_id", this.buku.genre_id);
      formData.append("price", this.buku.price);
      formData.append("cover", this.buku.cover);

      axios
        .put(`http://localhost:8000/api/edit-buku/${this.buku.id}`, formData, {
          headers: {
          'Content-Type': 'multipart/form-data'
        }
        })
        .then((response) => {
          console.log("Buku berhasil diubah:", response.data);
          this.successMessage = 'Data buku berhasil diubah';
        })
        .catch((error) => {
          console.error("Gagal mengubah data buku:", error);
          this.errorMessage = "Gagal mengubah data buku.";
        });
    },
    onFileChange(event) {
      this.buku.cover = event.target.files[0];
    },
  },
};
</script>

<template>
  <div class="container vh-100 pt-5">
    <div class="col-lg-8 mx-auto mt-3">
      <h1 class="text-center">Edit Buku</h1>

      <div v-if="errorMessage" class="alert alert-danger mt-3">
        {{ errorMessage }}
      </div>
      <div v-if="successMessage" class="alert alert-success mt-3">
        {{ successMessage }}
      </div>

      <form @submit.prevent="editBuku">
        <div class="my-3">
          <label for="title">Judul</label>
          <input type="text" class="form-control" id="title" v-model="buku.title" required />
        </div>
        <div class="my-3">
          <label for="author">Penulis</label>
          <input type="text" class="form-control" id="author" v-model="buku.author" required />
        </div>
        <div class="my-3">
          <label for="synopsis">Sinopsis</label>
          <textarea class="form-control" id="synopsis" v-model="buku.synopsis" required></textarea>
        </div>
        <div class="my-3">
          <label for="genre_id">Genre</label>
          <select class="form-control" id="genre_id" v-model="buku.genre_id" required>
            <option value="">Pilih Genre</option>
            <option v-for="genre in genres" :key="genre.genre_id" :value="genre.genre_id">
              {{ genre.genre }}
            </option>
          </select>
        </div>
        <div class="my-3">
          <label for="price">Harga</label>
          <input type="number" class="form-control" id="price" v-model="buku.price" required />
        </div>
        <div class="my-3">
          <label for="cover">Cover</label>
          <input type="file" class="form-control" id="cover" @change="onFileChange" required />
        </div>
        <button type="submit" class="btn btn-primary">Edit Buku</button>
      </form>
    </div>
  </div>
</template>
